{-------------------------------------------------------------------------------

    Angelscript 2.1.0 Delphi Adaption

    By Lars Peter Christiansen
    http://www.nzlab.dk

    Angelscript information can be found at http://www.angelcode.com
    
    This file uses Angelscript.dll, which is compiled using the official
    Angelscript 2.1.0 source code.


    12-04-2005:
    First release

-------------------------------------------------------------------------------}

unit AngelScript;

interface

const
  ASDLL = 'AngelScript.dll';

  ANGELSCRIPT_VERSION = 20100;

  // Calling conventions and flags
  asCALL_CDECL            = 0;
  asCALL_STDCALL          = 1;
  asCALL_THISCALL         = 2;
  asCALL_CDECL_OBJLAST    = 3;
  asCALL_CDECL_OBJFIRST   = 4;
  asCALL_GENERIC          = 5;

  // Object type flags

  asOBJ_CLASS             = 1;
  asOBJ_CLASS_CONSTRUCTOR = 2;
  asOBJ_CLASS_DESTRUCTOR  = 4;
  asOBJ_CLASS_ASSIGNMENT  = 8;
  asOBJ_CLASS_C           = (asOBJ_CLASS + asOBJ_CLASS_CONSTRUCTOR);
  asOBJ_CLASS_CD          = (asOBJ_CLASS + asOBJ_CLASS_CONSTRUCTOR + asOBJ_CLASS_DESTRUCTOR);
  asOBJ_CLASS_CA          = (asOBJ_CLASS + asOBJ_CLASS_CONSTRUCTOR + asOBJ_CLASS_ASSIGNMENT);
  asOBJ_CLASS_CDA         = (asOBJ_CLASS + asOBJ_CLASS_CONSTRUCTOR + asOBJ_CLASS_DESTRUCTOR + asOBJ_CLASS_ASSIGNMENT);
  asOBJ_CLASS_D           = (asOBJ_CLASS + asOBJ_CLASS_DESTRUCTOR);
  asOBJ_CLASS_A           = (asOBJ_CLASS + asOBJ_CLASS_ASSIGNMENT);
  asOBJ_CLASS_DA          = (asOBJ_CLASS + asOBJ_CLASS_DESTRUCTOR + asOBJ_CLASS_ASSIGNMENT);
  asOBJ_PRIMITIVE         = 16;
  asOBJ_FLOAT             = 17;

  // Behaviours

  asBEHAVE_CONSTRUCT     = 0;
  asBEHAVE_DESTRUCT      = 1;
  asBEHAVE_FIRST_ASSIGN  = 2;
  asBEHAVE_ASSIGNMENT    = 2;
  asBEHAVE_ADD_ASSIGN    = 3;
  asBEHAVE_SUB_ASSIGN    = 4;
  asBEHAVE_MUL_ASSIGN    = 5;
  asBEHAVE_DIV_ASSIGN    = 6;
  asBEHAVE_MOD_ASSIGN    = 7;
  asBEHAVE_OR_ASSIGN     = 8;
  asBEHAVE_AND_ASSIGN    = 9;
  asBEHAVE_XOR_ASSIGN    = 10;
  asBEHAVE_SLL_ASSIGN    = 11;
  asBEHAVE_SRL_ASSIGN    = 12;
  asBEHAVE_SRA_ASSIGN    = 13;
  asBEHAVE_LAST_ASSIGN   = 13;
  asBEHAVE_FIRST_DUAL    = 14;
  asBEHAVE_ADD           = 14;
  asBEHAVE_SUBTRACT      = 15;
  asBEHAVE_MULTIPLY      = 16;
  asBEHAVE_DIVIDE        = 17;
  asBEHAVE_MODULO        = 18;
  asBEHAVE_EQUAL         = 19;
  asBEHAVE_NOTEQUAL      = 20;
  asBEHAVE_LESSTHAN      = 21;
  asBEHAVE_GREATERTHAN   = 22;
  asBEHAVE_LEQUAL        = 23;
  asBEHAVE_GEQUAL        = 24;
  asBEHAVE_LOGIC_OR      = 25;
  asBEHAVE_LOGIC_AND     = 26;
  asBEHAVE_BIT_OR        = 27;
  asBEHAVE_BIT_AND       = 28;
  asBEHAVE_BIT_XOR       = 29;
  asBEHAVE_BIT_SLL       = 30;
  asBEHAVE_BIT_SRL       = 31;
  asBEHAVE_BIT_SRA       = 32;
  asBEHAVE_LAST_DUAL     = 32;
  asBEHAVE_INDEX         = 33;
  asBEHAVE_NEGATE        = 34;
  asBEHAVE_ADDREF        = 35;
  asBEHAVE_RELEASE       = 36;
  asBEHAVE_ALLOC         = 37;
  asBEHAVE_FREE          = 38;

  // Return codes

  asSUCCESS                              =  0;
  asERROR                                = -1;
  asCONTEXT_ACTIVE                       = -2;
  asCONTEXT_NOT_FINISHED                 = -3;
  asCONTEXT_NOT_PREPARED                 = -4;
  asINVALID_ARG                          = -5;
  asNO_FUNCTION                          = -6;
  asNOT_SUPPORTED                        = -7;
  asINVALID_NAME                         = -8;
  asNAME_TAKEN                           = -9;
  asINVALID_DECLARATION                  = -10;
  asINVALID_OBJECT                       = -11;
  asINVALID_TYPE                         = -12;
  asALREADY_REGISTERED                   = -13;
  asMULTIPLE_FUNCTIONS                   = -14;
  asNO_MODULE                            = -15;
  asNO_GLOBAL_VAR                        = -16;
  asINVALID_CONFIGURATION                = -17;
  asINVALID_INTERFACE                    = -18;
  asCANT_BIND_ALL_FUNCTIONS              = -19;
  asLOWER_ARRAY_DIMENSION_NOT_REGISTERED = -20;
  asAPP_CANT_INTERFACE_DEFAULT_ARRAY     = -21;

  // Context states

  asEXECUTION_FINISHED      = 0;
  asEXECUTION_SUSPENDED     = 1;
  asEXECUTION_ABORTED       = 2;
  asEXECUTION_EXCEPTION     = 3;
  asEXECUTION_PREPARED      = 4;
  asEXECUTION_UNINITIALIZED = 5;
  asEXECUTION_ACTIVE        = 6;
  asEXECUTION_ERROR         = 7;



type
  asIScriptEngine  = type pointer;
  asIScriptContext = pointer;
  asIScriptGeneric = pointer;
  asDWORD          = longword;
  asQWORD          = UInt64;
  asUPtr           = pointer;
  asUINT           = longword;
  asFUNCTION_t     = pointer;
  asOUTPUTFUNC_t   = procedure(text:pchar;param:pointer);cdecl;
  asBINARYFUNC_t   = procedure(ptr:pointer;size:integer;param:pointer);cdecl;
  asSTRINGFACTORY_t= pointer;//function(length:asUINT;s:pchar):pointer;cdecl;


// Engine
function	asCreateScriptEngine(version:asDWORD):asIScriptEngine;cdecl;external ASDLL;
function	asGetLibraryVersion:pchar;cdecl;external ASDLL;

// Context
function	asGetActiveContext:asIScriptContext;cdecl;external ASDLL;

// Thread support
function	asThreadCleanup:integer;cdecl;external ASDLL;

// Interface
Function asEngine_AddRef(e:asIScriptEngine):integer;cdecl;external ASDLL;
Function asEngine_Release(e:asIScriptEngine):integer;cdecl;external ASDLL;
Function asEngine_RegisterObjectType(e:asIScriptEngine; name:pchar;byteSize:integer; flags:asDWORD ):integer;cdecl;external ASDLL;
Function asEngine_RegisterObjectProperty(e:asIScriptEngine; obj:pchar; declaration:pchar;byteOffset:integer):integer;cdecl;external ASDLL;
Function asEngine_RegisterObjectMethod(e:asIScriptEngine; obj:pchar; declaration:pchar; funcPointer:asFUNCTION_t ; callConv:asDWORD ):integer;cdecl;external ASDLL;
Function asEngine_RegisterObjectBehaviour(e:asIScriptEngine; datatype:pchar; behaviour:asDWORD; declaration:pchar;funcPointer: asFUNCTION_t;callConv: asDWORD ):integer;cdecl;external ASDLL;
Function asEngine_RegisterGlobalProperty(e:asIScriptEngine; declaration:pchar;pointer:pointer):integer;cdecl;external ASDLL;
Function asEngine_RegisterGlobalFunction(e:asIScriptEngine;declaration:pchar;funcPointer:asFUNCTION_t;callConv:asDWORD):integer;cdecl;external ASDLL;
Function asEngine_RegisterGlobalBehaviour(e:asIScriptEngine;behaviour: asDWORD; declaration:pchar;funcPointer: asFUNCTION_t;callConv:asDWORD ):integer;cdecl;external ASDLL;
Function asEngine_RegisterStringFactory(e:asIScriptEngine;datatype:pchar;factoryFunc:asSTRINGFACTORY_t ;callConv: asDWORD ):integer;cdecl;external ASDLL;

Function asEngine_AddScriptSection(e:asIScriptEngine;module:pchar;name:pchar;code:pchar;codeLength:integer; lineOffset:integer = 0;makeCopy:boolean = true):integer;cdecl;external ASDLL;

Function asEngine_Build(e:asIScriptEngine;module:pchar;outFunc:asOUTPUTFUNC_t;outParam:pointer = nil):integer;cdecl;external ASDLL;
Function asEngine_Discard(e:asIScriptEngine; module:pchar):integer;cdecl;external ASDLL;
Function asEngine_GetModuleIndex(e:asIScriptEngine;module:pchar):integer;cdecl;external ASDLL;
Function asEngine_GetModuleNameFromIndex(e:asIScriptEngine; index:integer;length:pinteger = nil):pchar;cdecl;external ASDLL;
Function asEngine_GetFunctionCount(e:asIScriptEngine; module:pchar):integer;cdecl;external ASDLL;
Function asEngine_GetFunctionIDByIndex(e:asIScriptEngine; module:pchar;index:integer):integer;cdecl;external ASDLL;
Function asEngine_GetFunctionIDByName(e:asIScriptEngine; module:pchar;name:pchar):integer;cdecl;external ASDLL;
Function asEngine_GetFunctionIDByDecl(e:asIScriptEngine; module:pchar;decl:pchar):integer;cdecl;external ASDLL;
Function asEngine_GetFunctionDeclaration(e:asIScriptEngine;funcID:integer;length:pinteger = nil):pchar;cdecl;external ASDLL;
Function asEngine_GetFunctionName(e:asIScriptEngine; funcID:integer; length:pinteger = nil):pchar;cdecl;external ASDLL;
Function asEngine_GetFunctionSection(e:asIScriptEngine; funcID:integer;length:pinteger = nil):pchar;cdecl;external ASDLL;
Function asEngine_GetGlobalVarCount(e:asIScriptEngine;module:pchar):integer;cdecl;external ASDLL;
Function asEngine_GetGlobalVarIDByIndex(e:asIScriptEngine; module:pchar;index:integer):integer;cdecl;external ASDLL;
Function asEngine_GetGlobalVarIDByName(e:asIScriptEngine; module:pchar;name:pchar):integer;cdecl;external ASDLL;
Function asEngine_GetGlobalVarIDByDecl(e:asIScriptEngine; module:pchar;decl:pchar):integer;cdecl;external ASDLL;
Function asEngine_GetGlobalVarDeclaration(e:asIScriptEngine; gvarID:integer;length:pinteger = nil):pchar;cdecl;external ASDLL;
Function asEngine_GetGlobalVarName(e:asIScriptEngine; gvarID:integer; length:pinteger = nil):pchar;cdecl;external ASDLL;
Function asEngine_GetGlobalVarPointer(e:asIScriptEngine; gvarID:integer;var p:pointer):integer;cdecl;external ASDLL;
Function asEngine_GetImportedFunctionCount(e:asIScriptEngine; module:pchar):integer;cdecl;external ASDLL;
Function asEngine_GetImportedFunctionIndexByDecl(e:asIScriptEngine;module:pchar;decl:pchar):integer;cdecl;external ASDLL;
Function asEngine_GetImportedFunctionDeclaration(e:asIScriptEngine;module:pchar;importIndex:integer;length:pinteger = nil):pchar;cdecl;external ASDLL;
Function asEngine_GetImportedFunctionSourceModule(e:asIScriptEngine;module:pchar;importIndex:integer;length:pinteger = nil):pchar;cdecl;external ASDLL;
Function asEngine_BindImportedFunction(e:asIScriptEngine; module:pchar;importIndex:integer;funcID:integer):integer;cdecl;external ASDLL;
Function asEngine_UnbindImportedFunction(e:asIScriptEngine; module:pchar;importIndex:integer):integer;cdecl;external ASDLL;
Function asEngine_BindAllImportedFunctions(e:asIScriptEngine; module:pchar):integer;cdecl;external ASDLL;
Function asEngine_UnbindAllImportedFunctions(e:asIScriptEngine;module:pchar):integer;cdecl;external ASDLL;
Function asEngine_SetDefaultContextStackSize(e:asIScriptEngine; initial:asUINT;maximum:asUINT):integer;cdecl;external ASDLL;
function asEngine_CreateContext(e:asIScriptEngine;var context: asIScriptContext):integer;cdecl;external ASDLL;
function asEngine_ExecuteString(e:asIScriptEngine;module:pchar; script:pchar; outFunc:asOUTPUTFUNC_t ; outParam:pointer;var ctx:asIScriptContext;flags:asDWORD):integer;cdecl;external ASDLL;
function asEngine_SaveByteCode(e:asIScriptEngine; module:pchar;outFunc:asBINARYFUNC_t; outParam:pointer):integer;cdecl;external ASDLL;
function asEngine_LoadByteCode(e:asIScriptEngine; module:pchar;inFunc:asBINARYFUNC_t ; inParam:pointer):integer;cdecl;external ASDLL;

function asContext_AddRef(c:asIScriptContext):integer;cdecl;external ASDLL;
function asContext_Release(c:asIScriptContext):integer;cdecl;external ASDLL;
function asContext_GetEngine(c:asIScriptContext):asIScriptEngine;cdecl;external ASDLL;
function asContext_GetState(c:asIScriptContext):integer;cdecl;external ASDLL;
function asContext_Prepare(c:asIScriptContext;funcID:integer):integer;cdecl;external ASDLL;
function asContext_SetArgDWord(c:asIScriptContext; arg:asUINT ;value:asDWORD ):integer;cdecl;external ASDLL;
function asContext_SetArgQWord(c:asIScriptContext;arg:asUINT;value:asQWORD ):integer;cdecl;external ASDLL;
function asContext_SetArgFloat(c:asIScriptContext;arg:asUINT;value:single):integer;cdecl;external ASDLL;
function asContext_SetArgDouble(c:asIScriptContext;arg:asUINT ;value:double):integer;cdecl;external ASDLL;
function asContext_SetArgObject(c:asIScriptContext; arg:asUINT; obj:pointer):integer;cdecl;external ASDLL;
function asContext_GetReturnDWord(c:asIScriptContext):	asDWORD;cdecl;external ASDLL;
function asContext_GetReturnQWord(c:asIScriptContext):asQWORD;cdecl;external ASDLL;
function asContext_GetReturnFloat(c:asIScriptContext):single;cdecl;external ASDLL;
function asContext_GetReturnDouble(c:asIScriptContext):double;cdecl;external ASDLL;
function asContext_GetReturnObject(c:asIScriptContext):pointer;cdecl;external ASDLL;

function asContext_Execute(c:asIScriptContext):integer;cdecl;external ASDLL;
{$IFDEF AS_DEPRICATED}
	int              asContext_ExecuteStep(asIScriptContext *c, asDWORD flag);
{$ENDIF}

function asContext_Abort(c:asIScriptContext):integer;cdecl;external ASDLL;
function asContext_Suspend(c:asIScriptContext):integer;cdecl;external ASDLL;
function asContext_GetCurrentLineNumber(c:asIScriptContext; column:pinteger = nil):integer;cdecl;external ASDLL;
function asContext_GetCurrentFunction(c:asIScriptContext):integer;cdecl;external ASDLL;
function asContext_SetException(c:asIScriptContext;s:pchar):integer;cdecl;external ASDLL;
function asContext_GetExceptionLineNumber(c:asIScriptContext; column:pinteger=nil):integer;cdecl;external ASDLL;
function asContext_GetExceptionFunction(c:asIScriptContext):integer;cdecl;external ASDLL;
function asContext_GetExceptionString(c:asIScriptContext; length:pinteger = nil):pchar;cdecl;external ASDLL;
function asContext_SetLineCallback(c:asIScriptContext;callback:asUPtr;obj:pointer;callConv:integer):integer;cdecl;external ASDLL;
procedure asContext_ClearLineCallback(c:asIScriptContext);cdecl;external ASDLL;
function asContext_SetExceptionCallback(c:asIScriptContext; callback:asUPtr;obj:pointer;callConv:integer):integer;cdecl;external ASDLL;
procedure asContext_ClearExceptionCallback(c:asIScriptContext);cdecl;external ASDLL;
function asContext_GetCallstackSize(c:asIScriptContext):integer;cdecl;external ASDLL;
function asContext_GetCallstackFunction(c:asIScriptContext; index:integer):integer;cdecl;external ASDLL;
function asContext_GetCallstackLineNumber(c:asIScriptContext;index:integer;column:pinteger = nil):integer;cdecl;external ASDLL;

function asGeneric_GetEngine(g:asIScriptGeneric):asIScriptEngine;cdecl;external ASDLL;
function asGeneric_GetObject(g:asIScriptGeneric):pointer;cdecl;external ASDLL;
function asGeneric_GetArgDWord(g:asIScriptGeneric; arg:asUINT):asDWORD;cdecl;external ASDLL;
function asGeneric_GetArgQWord(g:asIScriptGeneric;arg:asUINT):asQWORD;cdecl;external ASDLL;
function asGeneric_GetArgFloat(g:asIScriptGeneric; arg:asUINT):single;cdecl;external ASDLL;
function asGeneric_GetArgDouble(g:asIScriptGeneric;arg:asUINT):double;cdecl;external ASDLL;
function asGeneric_GetArgObject(g:asIScriptGeneric; arg:asUINT):pointer;cdecl;external ASDLL;
function asGeneric_SetReturnDWord(val:asDWORD):integer;cdecl;external ASDLL;
function asGeneric_SetReturnQWord(val:asQWORD):integer;cdecl;external ASDLL;
function asGeneric_SetReturnFloat(val:single):integer;cdecl;external ASDLL;
function asGeneric_SetReturnDouble(val:double):integer;cdecl;external ASDLL;
function asGeneric_SetReturnObject(obj:pointer):integer;cdecl;external ASDLL;


implementation

end.
